; File:     Convol.s
; Created:  2004-04-05
; Modified: 2004-04-12
; Author:   Safranek David (Safrad)
; E-Mail:   safrad@email.cz

;Rozbaleni cyklu 5x (pro jinou delku vlny je treba pridat instrukce) 1363/1260
;Rozbaleni 4xA+1xB (obecna delka vlny) 2066/1913

;----------------------------------------------------------------------------------------------------
;
;  original code by Ing. Tomas Zahradnicky, Jr.
;
;  zahradt@cslab.felk.cvut.cz
;
;----------------------------------------------------------------------------------------------------
; data section starts here
;----------------------------------------------------------------------------------------------------

	.data					

    
WAVE:	.word	1,3,10,3,1			
SPC1:	.space	64				

; input data are here 5 rows by 10 elements

LONG:	
    .word	0,0,1,0,1,0,0,0,0,0		
	.word	0,0,1,0,0,0,0,0,0,0
	.word	0,0,0,0,2,0,0,0,0,0
	.word	0,0,0,0,0,1,0,0,0,0
	.word	0,0,0,0,0,0,0,1,0,0

SPC2:	.space	64				


; result will go here
    
    .word   0xBBBBBBBB
RESULT:	
    .word	0,0,0,0,0,0,0,0,0,0		
	.word	0,0,0,0,0,0,0,0,0,0
	.word	0,0,0,0,0,0,0,0,0,0
	.word	0,0,0,0,0,0,0,0,0,0
	.word	0,0,0,0,0,0,0,0,0,0
    .word   0xEEEEEEEE

;----------------------------------------------------------------------------------------------------
; code-section starts here
;----------------------------------------------------------------------------------------------------
	.text					
	.global main

main:	
; load address of input data into R3
    lhi	    r3,LONG>>16
	ori	    r3,r0,LONG&0xFFFF
	
; load address of wave data into R4
	lhi	    r4,WAVE>>16
	ori     r4,r0,WAVE&0xFFFF

; load address of result into R5
	lhi	    r5,RESULT>>16
	ori	    r5,r0,RESULT&0xFFFF
	
; move in input data to the end since we process it from the end
; to the beginninng while wave is processed in reverse order.
	addi	r5,r5,49<<2
	addi	r3,r3,49<<2
	sub r3,r3,12
	add	    r4,r4,4
	
; initialize R9 and R15 with 49 and 4
	add	    r9,r0,200
		
	add	    r10,r3,r0
; outer cycle for(outer=50; --outer; outer>=0)
outer:	
	
	subi	r9,r9,4
	
	ori	    r10,r3,0
	subi	r3,r3,4
		
	
	ori	    r12,r0,0 ; Zero r12
	
	ori r17,r0,1
	
	add	    r6, r4, r0
	
	Inner4:
	
	lw	    r8,12(r6)
	lw	    r11,12(r10)
	lw	    r19,8(r6)
	mult	r13,r11,r8
	lw	    r20,8(r10)
	lw	    r25,4(r6)
	mult	r21,r20,r19
	add	    r12,r12,r13
	lw	    r26,4(r10)
	lw	    r31,0(r6)
	mult	r27,r26,r25
	add	    r12,r12,r21
	lw	    r1,0(r10)
	subi	r6,r6,16
	mult	r2,r1,r31
	add	    r12,r12,r27
	subi r17, r17, 1
	subi	r10,r10,16

	add	    r12,r12,r2
	
	bnez r17, Inner4
	
	ori r17,r0,1
	Inner1:
	
	lw	    r8,12(r6)
	lw	    r11,12(r10)
	subi	r6,r6,4
	mult	r13,r11,r8
	subi r17, r17, 1
	
	subi	r10,r10,4
	
	
	add	    r12,r12,r13
	
	bnez r17, Inner1
	

	sw	    0(r5),r12
	subi	r5,r5,4
	
	
	
	
	
	
	bnez	r9,outer
	
;	j	    outer

; real end
end:	
    trap 0	